<?php
/**
 * Create required pages
 */

function question_pages_init() {
    global $wpdb;
    //update_option('question_pages_created', 0);
    if(get_option('question_pages_created') != 2) {
        // Questions (main page)
        $post = array();
        $post['post_title'] = 'Questions';
        $post['post_type'] = 'page';
        $post['post_status'] = 'publish';
        $post['post_content'] = '[wpanswers_home]';
        $id = wp_insert_post($post);
        
        // Open Questions
        $post = array();
        $post['post_title'] = 'Open Questions';
        $post['post_type'] = 'page';
        $post['post_status'] = 'publish';
        $post['post_content'] = '[wpanswers_open_questions]';
        $id = wp_insert_post($post);
        
        // set template
        update_post_meta($id, "_wp_page_template", "open.php");
        
        // Popular
        $post = array();
        $post['post_title'] = 'Popular Questions';
        $post['post_type'] = 'page';
        $post['post_status'] = 'publish';
        $post['post_content'] = '[wpanswers_popular_questions]';
        $id = wp_insert_post($post);
        
        // set template
        update_post_meta($id, "_wp_page_template", "popular.php");
        
        // Top Users
        $post = array();
        $post['post_title'] = 'Top Users';
        $post['post_type'] = 'page';
        $post['post_status'] = 'publish';
        $post['post_content'] = '[wpanswers_top_users]';
        $id = wp_insert_post($post);
        
        // set template
        update_post_meta($id, "_wp_page_template", "top-users.php");
        
        
        // Edit Profile
        $post = array();
        $post['post_title'] = 'Edit Profile';
        $post['post_type'] = 'page';
        $post['post_status'] = 'publish';
        $post['post_content'] = '[wpanswers_edit_profile]';
        $id = wp_insert_post($post);
        update_option('edit_page_id', $id);
        // set template
        update_post_meta($id, "_wp_page_template", "edit-profile.php");

        
        // View Profile
        $post = array();
        $post['post_title'] = 'View Profile';
        $post['post_type'] = 'page';
        $post['post_status'] = 'publish';
        $post['post_content'] = '[wpanswers_view_profile]';
        $id = wp_insert_post($post);
        update_option('viewprofile_page_id', $id);
        // set template
        update_post_meta($id, "_wp_page_template", "view-profile.php");
        
        
        // Signup
        $post = array();
        $post['post_title'] = 'Signup';
        $post['post_type'] = 'page';
        $post['post_status'] = 'publish';
        $post['post_content'] = '[wpanswers_signup]';
        $id = wp_insert_post($post);
        update_option('signup_page_id', $id);
        // set template
        update_post_meta($id, "_wp_page_template", "signup.php");
        
        // Forgot password
        $post = array();
        $post['post_title'] = 'Forgot Password';
        $post['post_type'] = 'page';
        $post['post_status'] = 'publish';
        $post['post_content'] = '[wpanswers_forgot_password]';
        $id = wp_insert_post($post);
        
        // set template
        update_post_meta($id, "_wp_page_template", "forgot-password.php");
        
        
        // Submit question
        $post = array();
        $post['post_title'] = 'Submit Question';
        $post['post_type'] = 'page';
        $post['post_status'] = 'publish';
        $post['post_content'] = '[wpanswers_submit_question]';
        $id = wp_insert_post($post);
        update_option('submit_page_id', $id);
        // set template
        update_post_meta($id, "_wp_page_template", "submit.php");
        update_option('question_pages_created', 2);
    }
}

add_action('init', 'question_pages_init');