<?php
/**
 * Handles "ask a question" functionality.
 */

require_once(ABSPATH . 'wp-includes/pluggable.php');
require_once(ABSPATH . 'wp-includes/post.php');
session_start();
if(!empty($_POST['ask_a_question'])) {
    // check if title and content are filled
    if(empty($_POST['post_title']) || empty($_POST['content'])) {
        wp_safe_redirect($_POST['redirect_to']);
        exit;
    }
    if(is_user_logged_in()) {
        
        if($_POST['post_recaptcha'] == '1') {
            // check recaptcha first
            $currentTheme = wp_get_theme();
            $themeName = str_replace(' ', '_', strtolower($currentTheme->Name));
            $opt = get_alloptions();
            
            $up_opt = unserialize($opt['up_themes_'.$themeName]); 

            if ($_POST["recaptcha_challenge_field"]) {
                $resp = recaptcha_check_answer ($up_opt['recaptcha_private_key'],
                                                $_SERVER["REMOTE_ADDR"],
                                                $_POST["recaptcha_challenge_field"],
                                                $_POST["recaptcha_response_field"]);
        
                if (!$resp->is_valid) {
                    $_SESSION['recaptcha_error'] = $resp->error;
                    $_SESSION['post_content'] = $_POST['content'];
                    $_SESSION['post_title'] = $_POST['post_title'];
                    wp_safe_redirect($_POST['redirect_to']);
                    exit;
                }
            }
        }
        
        $user = wp_get_current_user();
        $post = array(
            'comment_status' => 'open',  // 'closed' means no comments.
            'ping_status' => 'open', // 'closed' means pingbacks or trackbacks turned off
            'post_author' => $user->data->ID, //The user ID number of the author.
            'post_content' => $_POST['content'], //The full text of the post.
            'post_status' => 'publish',  //Set the status of the new post.
            'post_title' => $_POST['post_title'], //The title of your post.
            'post_type' => 'question', //You may want to insert a regular post, page, link, a menu item or some custom post type
        );

        $id = wp_insert_post($post);
        unset($_SESSION['post_content']);
        unset($_SESSION['post_title']);
        // Need to call do_action("init") for custom post types to work: taxonomies, permalinks etc.
        // WP_Rewrite may be not initialized yet
        global $wp_rewrite;
        if(!is_object($wp_rewrite)) {
            $wp_rewrite = new WP_Rewrite();
        }
        do_action('init');
        
        wp_set_object_terms($id, array((int)$_POST['question_category']), 'question_category');
        wp_set_object_terms($id, $_POST['tags'], 'question_tag');

        if(!empty($id) && $id > 0) {
            wp_redirect(get_bloginfo('url')."/?p=$id");
            exit;
        }
        
    }
    else {
        wp_redirect(get_bloginfo('url')."/?p=".get_option('signup_page_id'));
        exit;
    }
}