<?php
/**
 * Handles "report post" functionality
 */

/**
 * Create "reported_comments" table if it doesn't exist yet
 *
 */
function reported_comments_init() {
    global $wpdb, $table_prefix;
    if(get_option('reported_comments_created') != '1') {
        $table_name = $table_prefix.'reported_comments';
        $wpdb->query(
            "CREATE TABLE IF NOT EXISTS ".$table_name." (
                `id` int(9) NOT NULL PRIMARY KEY AUTO_INCREMENT,
                `user_id` int(9) NOT NULL,
                `comment_id` int(9) NOT NULL,
                unique comment_id(comment_id)
            );
            "
        );
        update_option('reported_comments_created', '1');
    }
}


function report_js_init() {
    echo '
    <script type="text/javascript">
    jQuery(document).ready(function() { 
        jQuery("a.reportme").click(function(e) {
            e.preventDefault;
            var commentID = jQuery(this).attr("commentid");
            var action = "reportme";
            
            jQuery.get("'.get_bloginfo('home').'/?"+action+"="+commentID, function(data) {
                if(data.updated) {
                    jQuery("#comment-"+commentID).addClass("reported");
                    jQuery("#report_"+commentID).remove();
                }
            });
            return false;
        });
    });
    </script>
    ';
}

/**
 * "report comment" functionality - insert reported comment id into separate wp table
 *
 * @param int $user_id
 * @param int $comment_id
 */
function report_comment($user_id, $comment_id) {
    global $table_prefix, $wpdb;
    $table_name = $table_prefix.'reported_comments';
    $sql = 'INSERT into '.$table_name.' (user_id, comment_id) VALUES ("'.$user_id.'", "'.$comment_id.'") ON DUPLICATE KEY UPDATE comment_id="'.($comment_id).'"';
    $wpdb->query($sql);
    header("content-type: text/json");
    echo json_encode(array('updated' => '1'));
    exit;
}

add_action('init', 'reported_comments_init');
add_action('wp_footer', 'report_js_init');

/**
 * Handle ajax call "report this comment"
 */

if($_GET['reportme']) {
    require_once(ABSPATH . 'wp-includes/pluggable.php');
    if(!is_user_logged_in()) return;
    $user = wp_get_current_user();
    if(isset($user->ID)) {
        report_comment((int)$user->ID, (int)$_GET['reportme']);
    }
}