<?php
/**
 * Handles shortcodes (when plugin used without theme)
 * Represents custom theme pages
 */

// [wpanswers_top_users]
function shortcode_top_users($atts) {
    global $wpdb, $table_prefix;

    $users = $wpdb->get_results("select u.*, IFNULL(p.points, 0) as u_points from ".$wpdb->users." u left join ".$table_prefix.'user_points'." p on u.ID=p.user_id order by u_points desc limit 20"); 
    $return = '';
    foreach ($users as $user) {
        $return .= '
        <div class="topusers" style="clear:left;">
            <p class="topusersimg">
            <a href="'.get_bloginfo('home').'/?p='.get_option('viewprofile_page_id').'&profile='.($user->user_login).'" >'.get_user_avatar($user->ID).'</a></p>
            <div class="submittedbyhome"><a href="'.get_link_to_profile($user->user_login).'" >'.$user->display_name.'</a> | Points: '. $user->u_points.'</a></div>
        </div>';
    }	
    return $return;
}
add_shortcode( 'wpanswers_top_users', 'shortcode_top_users' );

// [wpanswers_archive_questions]
function shortcode_archive_questions($atts) {
    global $post;
    $post_name = $post->post_name;
    $paged = (get_query_var('paged')) ? get_query_var('paged') : 1;
    query_posts( 'post_type=question&paged='.$paged);
    $return  = '';
    while ( have_posts() ) : the_post();
        $return .= '<div '.get_post_class( 'question').' id="post-'.get_the_ID().'">
        <div class="questionnumber"><p><a href="'. get_permalink(get_the_ID()).'#comments">'.get_comments_number( '' . __('0', 'wp-answers') . '', '' . __('1', 'wp-answers') . '', '' . __('%', 'wp-answers') . '' ).'</a></p></div>
        <div class="questionmain">
        <h2 class="questiontitle"><a href="'. get_permalink(get_the_ID()).'">'.get_the_title().'</a></h2>
        <ul class="questionmeta">
        <li>'. __('Asked in:','wp-answers') . get_the_term_list(get_the_id(), 'question_category') . '</li>
        <li>'. __('Asked By','wp-answers') . ' <a class="url fn n" href="' . get_link_to_profile(get_the_author_meta('user_login')) . '">' .get_the_author(). '</a></li>
        <li>Asked on '. get_the_time('F j, Y') .'</li>
        </div>
        </ul>
        </div><!-- End Question-->';
    endwhile;
    
    $return .= get_wpanswers_pagination('', 2, $post_name);
    wp_reset_query();
    return $return;

}
add_shortcode( 'wpanswers_archive_questions', 'shortcode_archive_questions' );

// [wpanswers_signup]
function shortcode_signup($atts) {
    if ( get_option('users_can_register') == false ) {
	   return "<p>Sorry,At this time user registration is disabled. We will open registration soon!</p>";
    }

    $return = '<p>';
    $return .= __('Signup for an account and start participating in our site today!','wp-answers');
    $return .= '</p>';
    
    $return .= '<div class="errors">';
 
    if(!empty($_SESSION['_errors'])) {
        $return .= implode('<br/>', $_SESSION['_errors']);
        unset($_SESSION['_errors']);
    }
    $return .= '</div>';

    $return .= '<form name="userinfo" class="userinfo" method="POST" action="'.get_option('home').'/?l=sf'.'">

    <p>
    <label class="formlabel">'. __('Username:','wp-answers') .'</label><br />
    <input name="log" size="30" maxlength="140" id="user_name" placeholder="Username" type="text" class="input">
    </p>
    
    <p>
    <label class="formlabel">'. __('Email:','wp-answers') .'</label><br />
        <input name="email" size="30" maxlength="140" id="user_email" placeholder="your@email.here" type="text" class="input">
    </p>
    
    <p>
    <label class="formlabel">'. __('Password:','wp-answers') .'</label><br />
    <input name="pass" type="password" id="pass1" />
    </p>
    
    <p>
    <input type="hidden" name="signup" value="1" />
    <input type="hidden" name="redirect_to" value="'. get_permalink(get_the_id()) .'" />';
    global $up_options;
    if($up_options->recaptcha_signup == 'true') {
        global $error, $publickey;
        $return .= '<div id="recaptcha">'.recaptcha_get_html($up_options->recaptcha_public_key, $_SESSION['recaptcha_error']).'</div>';
        if(isset($_SESSION['recaptcha_error'])) {
            unset($_SESSION['recaptcha_error']);
        }
        $return .= '<input type="hidden" name="post_recaptcha" value="1">';
    }

    $return .= '
    <input type="submit" name="Submit" value="Signup &raquo;" class="loginbutton white" />
    </p>
    </form>
    
    <h2 class="formtitle">'. __('Social Signup','wp-answers') .'</h2>
    
    <p>'. __('You can also login with your Facebook or Twitter account','wp-answers') .'</p>
    
    <a href="'. get_option('home').'/?l=tw' .'"><img src="'. get_template_directory_uri() .'/img/twitter-button.png'.'" width="133" height="24" class="twitterbutton"/></a>
    <div id="fbconnect">
        <fb:login-button scope="offline_access,publish_stream" onlogin="location.href=\''. get_option('home').'/?l=fb'.'\';">Log in with Facebook</fb:login-button>
    </div>';
    
    return $return;
}
add_shortcode( 'wpanswers_signup', 'shortcode_signup' );

// [wpanswers_popular_questions]
function shortcode_popular_questions($atts) {
    global $post;
    $post_name = $post->post_name;
    
    $paged = (get_query_var('paged')) ? get_query_var('paged') : 1;
    query_posts('post_type=question&orderby=comment_count&order=DESC&paged='.$paged); 

    $return = '';
    while ( have_posts() ) : the_post();
        $return .= '<div '.get_post_class( 'question').' id="post-'. get_the_ID() .'">
        <div class="questionnumber"><p><a href="'. get_permalink(get_the_ID()).'#comments">'. get_comments_number( '' . __('0', 'wp-answers') . '', '' . __('1', 'wp-answers') . '', '' . __('%', 'wp-answers') . '' ).'</a></p></div>
        <div class="questionmain">
        <h2 class="questiontitle"><a href="'. get_permalink() .'">'. get_the_title() .'</a></h2>
        <ul class="questionmeta">
        <li>'. __('Asked in:','wp-answers') .' '. get_the_term_list(get_the_ID(), 'question_category') .'</li>
        <li>'.__('Asked By','wp-answers') .' '.'<a class="url fn n" href="'. get_link_to_profile(get_the_author_meta('user_login')) .'">'. get_the_author() .'</a></li>
        <li>Asked on '.get_the_time('F j, Y').'</li>
        </div>
        </ul>
        </div><!-- End Question-->';
    endwhile;
    
    $return .= get_wpanswers_pagination('', 2, $post_name);
    wp_reset_query();

    return $return;
}
add_shortcode( 'wpanswers_popular_questions', 'shortcode_popular_questions' );

// [wpanswers_home] (main page)
function shortcode_home($atts) {
    global $post;
    $post_name = $post->post_name;
    $paged = (get_query_var('paged')) ? get_query_var('paged') : 1;
    query_posts( 'post_type=question&paged='.$paged);
    $return  = '';
    while ( have_posts() ) : the_post();
        $return .= '<div class="'.implode(' ', get_post_class( 'question')).'" id="post-'.get_the_ID().'">
        <div class="questionnumber"><p><a href="'. get_permalink(get_the_ID()).'#comments">'.get_comments_number( '' . __('0', 'wp-answers') . '', '' . __('1', 'wp-answers') . '', '' . __('%', 'wp-answers') . '' ).'</a></p></div>
        <div class="questionmain">
        <h2 class="questiontitle"><a href="'. get_permalink(get_the_ID()).'">'.get_the_title().'</a></h2>
        <ul class="questionmeta">
        <li>'. __('Asked in:','wp-answers') . get_the_term_list(get_the_id(), 'question_category') . '</li>
        <li>'. __('Asked By','wp-answers') . ' <a class="url fn n" href="' . get_link_to_profile(get_the_author_meta('user_login')) . '">' .get_the_author(). '</a></li>
        <li>Asked on '. get_the_time('F j, Y') .'</li>
        </div>
        </ul>
        </div><!-- End Question-->';
    endwhile;
    
    $return .= get_wpanswers_pagination('', 2, $post_name);
    wp_reset_query();
    return $return;
    
}
add_shortcode( 'wpanswers_home', 'shortcode_home' );

// used in "open questions" shortcode
function shortcode_filter_where( $where = '' ) {
	$where .= " AND comment_count=0";
	return $where;
}

// [wpanswers_open_questions] 
function shortcode_open_questions($atts) {
    global $post;
    $post_name = $post->post_name;
    $paged = (get_query_var('paged')) ? get_query_var('paged') : 1;
    
    add_filter( 'posts_where', 'shortcode_filter_where' );
    query_posts('post_type=question&paged='.$paged); 
    remove_filter( 'posts_where', 'shortcode_filter_where' );
    
    $return  = '';
    while ( have_posts() ) : the_post();
        $return .= '<div '.get_post_class( 'question').' id="post-'.get_the_ID().'">
        <div class="questionnumber"><p><a href="'. get_permalink(get_the_ID()).'#comments">'.get_comments_number( '' . __('0', 'wp-answers') . '', '' . __('1', 'wp-answers') . '', '' . __('%', 'wp-answers') . '' ).'</a></p></div>
        <div class="questionmain">
        <h2 class="questiontitle"><a href="'. get_permalink(get_the_ID()).'">'.get_the_title().'</a></h2>
        <ul class="questionmeta">
        <li>'. __('Asked in:','wp-answers') . get_the_term_list(get_the_id(), 'question_category') . '</li>
        <li>'. __('Asked By','wp-answers') . ' <a class="url fn n" href="' . get_link_to_profile(get_the_author_meta('user_login')) . '">' .get_the_author(). '</a></li>
        <li>Asked on '. get_the_time('F j, Y') .'</li>
        </div>
        </ul>
        </div><!-- End Question-->';
    endwhile;
    
    $return .= get_wpanswers_pagination('', 2, $post_name);
    wp_reset_query();
    return $return;
    
}
add_shortcode( 'wpanswers_open_questions', 'shortcode_open_questions' );

// [wpanswers_forgotpassword]
function shortcode_forgotpassword($atts) {
    
    if(isset($_GET['success'])) {
        _e("Please check your email for further instructions.", 'wp-answers');
    }
    $return = '
    <form name="lostpasswordform" class="userinfo" action="'.get_bloginfo('home').'/wp-login.php?action=retrievepassword" method="post">
	<p>
		<label class="formlabel">Username or E-mail:<br />
		<input type="text" name="user_login" id="user_login" class="input" value="" size="20" tabindex="10" />
		</label>
	</p>
	<input type="hidden" name="redirect_to" value="'. get_permalink(get_the_id()).'/?success" />
	<input type="hidden" name="action" value="retrievepassword" />
	<p>
	<input type="submit" name="wp-submit" class="loginbutton white" value="Get New Password" tabindex="100" />
	</p>
    </form>
    ';
    return $return;
}
add_shortcode( 'wpanswers_forgot_password', 'shortcode_forgotpassword' );

// [wpanswers_editprofile]
function shortcode_editprofile($atts) {
    global $current_user;
    get_currentuserinfo();
    $location = get_user_meta($current_user->ID, 'location');
    $location = $location[0];
    $occupation = get_user_meta($current_user->ID, 'occupation');
    $occupation = $occupation[0];
    $interests = get_user_meta($current_user->ID, 'interests');
    $interests = $interests[0];
    
    $return = '';
    $return .= '<form action="'. get_option('home').'/?edit-profile" name="userinfo" class="userinfo" enctype="multipart/form-data" method="POST">

    <p>
    <label class="formlabel">'. __('Username:','wp-answers').'</label><br />
    <input name="username" size="30" maxlength="140" id="username" value="'.$current_user->user_login.'" type="text" class="input">
    </p>
    
    <p>
    <label class="formlabel">'. __('Email:','wp-answers'). '</label><br />
    <input name="email" size="30" maxlength="140" id="user_email" value="'. $current_user->user_email .'" type="text" class="input">
    </p>
    
    <p>
    <label class="formlabel">'. __('Website:','wp-answers'). '</label><br />
    <input name="url" size="30" maxlength="140" id="user_url" value="'. $current_user->user_url .'" type="text" class="input">
    </p>
    
    <p>
    <label class="formlabel">'. __('Location:','wp-answers') .'</label><br />
    <input name="location" size="30" maxlength="140" id="from" value="'.$location.'" type="text" class="input">
    </p>
    
    <p>
    <label class="formlabel">'. __('Occupation:','wp-answers') .'</label><br />
    <input name="occupation" size="30" maxlength="140" id="occ" value="'.$occupation.'" type="text" class="input">
    </p>
    
    <p>
    <label class="formlabel">'. __('Interests:','wp-answers'). '</label><br />
    <input name="interests" size="30" maxlength="140" id="interests" value="'.$interests.'" type="text" class="input">
    </p>
    
    <p>
    <label class="formlabel">'. __('Avatar:','wp-answers') .'</label><br />
    
    '.get_user_avatar($current_user->ID).'<br />
    <input name="avatar"type="file" class="input">
    <input type="hidden" name="MAX_FILE_SIZE" value="10" />
    </p>
    
    
    <h2 class="formtitle">'. __('Change Password','wp-answers') .'</h2>
    
    
    <p>'. __('To change your password, enter a new password twice below:','wp-answers') .'</p>
    
    <p>
    <label class="formlabel">'. __('New password:','wp-answers') .'</label><br /><input name="pass1" type="password" id="pass1"   />
    </p>
    
    <p>
    <label class="formlabel">'. __('Enter it again:','wp-answers') .'</label><br /><input name="pass2" type="password" id="pass2"  />
    </p>
    
    <p>
    <input type="hidden" name="editprofile" value="1">
    <input type="hidden" name="current_user" value="'. $current_user->ID. '">
    <input type="hidden" name="redirect_to" value="'. get_permalink(). '">
    <input type="submit" name="Submit" value="Update Profile &raquo;" class="loginbutton white" />
    </p>
    </form>
    ';
    return $return;  
    
}
add_shortcode( 'wpanswers_edit_profile', 'shortcode_editprofile' );


function shortcode_viewprofile($atts) {
    if(!isset($_GET['profile']) || empty($_GET['profile'])) return;
    
    global $_user_data, $_user_meta, $up_options, $wpdb, $table_prefix;
    $return = '';
    $return .= '
    <p>
    '. __('User points', 'wp-answers').'<br/>
    ';
        $table_name = $table_prefix.'user_points';
        $points = $wpdb->get_var("select points from ".$table_name." where user_id='".$_user_data->ID."'");
        if(empty($points)) {
            $points = 0;
        }
    $return .= $points;
    $return .= '
    </p>
    
    <p>
    '.__('Member Since', 'wp-answers').'<br/>
    '.date("M j, Y", strtotime($_user_data->user_registered)).' ('.readable_time(strtotime($_user_data->user_registered), 1).')
    </p>
    
    <p>
    '.__('Website', 'wp-answers').'<br/>
    <a href="'.$_user_data->user_url.'">'.$_user_data->user_url.'</a>
    </p>
    
    <p>
    '. __('Location', 'wp-answers').'<br/>
    '.$_user_data->location.'
    </p>
    
    <p>
    '.__('Occupation', 'wp-answers').'<br/>
    '. $_user_data->occupation.'
    </p>
    
    <p>
    '. __('Interests', 'wp-answers').'<br/>
    '. $_user_data->interests.'
    </p>
    
    <p>
    '. __('Avatar', 'wp-answers').'<br/>
    '.get_user_avatar($_user_data->ID).'
    </p>
    
    <div style="clear:both"></div>
    
    <h3>'.__('Recent Answers', 'wp-answers').'</h3>
    <ul>';
    
    $comments = $wpdb->get_results('select c.*, p.post_title from '.$wpdb->comments.' c left join '.$wpdb->posts.' p on c.comment_post_ID=p.ID where c.user_id="'.$_user_data->ID.'" and p.post_type="question" group by c.comment_post_ID order by c.comment_date DESC limit 10');
    foreach ($comments as $comment) {
        $return .= '<li><a href="'.get_permalink($comment->comment_post_ID).'">'.$comment->post_title.'</a> <span class="info">'.__('Started', 'wp-answers').' '.readable_time(strtotime($comment->comment_date)).' '.__('ago', 'wp-answers').'</span></li>';
    }
    
    $return .= '</ul>
    
    <h3>'. __('Recent Questions', 'wp-answers').'</h3>
    <ul>';
    
    $posts = $wpdb->get_results('select p.*, max(c.comment_date) as comment_date from '.$wpdb->posts.' p left join '.$wpdb->comments.' c on c.comment_post_ID=p.ID where p.post_author="'.$_user_data->ID.'" and p.post_type="question" group by p.ID order by p.post_date DESC limit 10');
    foreach ($posts as $post) {
        if($post->comment_count >= 1) {
            $replies = __('Most recent reply', 'wp-answers');
            $replies .= ' '.readable_time(strtotime($post->comment_date)).' '.__('ago', 'wp-answers');
        }
        else {
            $replies = __('No replies', 'wp-answers');
        }
        $return .= '<li><a href="'.get_permalink($post->ID).'">'.$post->post_title.'</a>  <span class="info">'.__('Started', 'wp-answers').' '.readable_time(strtotime($post->post_date)).' '.__('ago', 'wp-answers').' '.$replies.'</span></li>';
    }
    $return .= '</ul>';
    
    return $return;
}
add_shortcode( 'wpanswers_view_profile', 'shortcode_viewprofile' );

// [wpanswers_submit_question]

function shortcode_submit_question($atts) {
    $return = '
        <form action="" method="POST">
            <p>
            <label class="formlabel">'. __('Question Title','wp-answers') .'</label><br />
            <input name="post_title" type="text" class="input" value="'. (!empty($_GET['q']) ? $_GET['q'] : $_SESSION['post_title'] ).'" />
            </p>
            
            <p>
            <label class="formlabel">'.__('Question Details','wp-answers') .'</label><br />
            <textarea name="content"  value="" type="text" class="questionarea" />'. $_SESSION['post_content'].'</textarea>
            </p>
            
            <p><label for="tags-input" class="formlabel">Enter some keywords about your question, separate with commas:</label><br />
            <input id="tags_input" class="input" name="tags" type="text"  tabindex="4" />
            </p>
            	
            	<label for="post_category" class="formlabel">Choose a Category:</label><br />';
    
     $categories = get_terms('question_category', array('hide_empty' => false)); 
     $return .= '<select name="question_category" id="post_category" class="postform" >';
            	    
     foreach ($categories as $category) {
        $return .= '<option value="'.$category->term_id.'">'.$category->name.'</option>';
     }
     
     $return .= '</select>';
            
     global $up_options;
     if($up_options->recaptcha_new_question == 'true') {
        global $error, $publickey;
            $return .= '<div id="recaptcha">'.recaptcha_get_html($up_options->recaptcha_public_key, $_SESSION['recaptcha_error']).'</div>';
            if(isset($_SESSION['recaptcha_error'])) {
                    unset($_SESSION['recaptcha_error']);
            }
                $return .= '<input type="hidden" name="post_recaptcha" value="1">';
     }
     $return .= '
            <p>
            <input type="hidden" name="ask_a_question" value="1">
            <input type="hidden" name="redirect_to" value="'.$_SERVER['REQUEST_URI'].'">
            <input type="hidden" name="up" value="'.$up_options->points_per_question.'">    
            <input type="submit" name="Submit" value="Submit &raquo;" class="loginbutton white" />
            </p>
            </form>
    ';
    return $return;
}
add_shortcode( 'wpanswers_submit_question', 'shortcode_submit_question' );