<?php
/**
 * Handles signup form.
 */

add_action('user_register', 'user_register_email');
if(get_option('users_can_register') == false) return;
if(is_user_logged_in()) return;
session_start();
if(!empty($_POST['signup'])) {
    $currentTheme = wp_get_theme();
    $themeName = str_replace(' ', '_', strtolower($currentTheme->Name));
    $opt = get_alloptions();
    
    $up_opt = unserialize($opt['up_themes_'.$themeName]); 

    $opt_recaptcha = false;
    
    if(isset($up_opt['recaptcha_private_key']) && !empty($up_opt['recaptcha_private_key'])) {
        $opt_recaptcha = true;
    }
    
    if($_POST['post_recaptcha'] == '1' && $opt_recaptcha == true) {
        // check recaptcha first
        if ($_POST["recaptcha_challenge_field"]) {
            $resp = recaptcha_check_answer ($up_opt['recaptcha_private_key'],
                                            $_SERVER["REMOTE_ADDR"],
                                            $_POST["recaptcha_challenge_field"],
                                            $_POST["recaptcha_response_field"]);
    
            if (!$resp->is_valid) {
                session_start();
                $_SESSION['recaptcha_error'] = $resp->error;
                wp_safe_redirect($_POST['redirect_to']);
                exit;
            }
        }
    }
    include_once( ABSPATH . WPINC . '/registration.php' );
    
  	$userdata = array(
	    	'user_pass' => $_POST['pass'],
    		'user_login' => strip_tags($_POST['log']),
    		'display_name' => strip_tags($_POST['log']),
    		'user_url' => '',
    		'user_email' => $_POST['email']
  	);
  	$_SESSION['tmp_pass'] = $_POST['pass'];			
  	$wpuserid = wp_insert_user($userdata);
  	
  	if(is_object($wpuserid)) {
  	    unset($_SESSION['tmp_pass']);
  	    $_SESSION['_errors'] = array();
  	    foreach ($wpuserid as $error) {
  	        if(empty($error)) continue;
  	        foreach ($error as $e) {
  	            $_SESSION['_errors'][] = $e[0];
  	        }
  	    }
  	    if(!empty($_POST['redirect_to'])) {
      	    wp_safe_redirect($_POST['redirect_to']);
      	}
      	else {
      	    wp_safe_redirect(get_option('home'));
      	}
      	exit;
  	}

	if(!empty($wpuserid)) {
	    
	    
      	wp_set_auth_cookie($wpuserid, true, false);
      	wp_set_current_user($wpuserid);
      	if(!empty($_POST['redirect_to'])) {
      	    wp_safe_redirect($_POST['redirect_to']);
      	}
      	else {
      	    wp_safe_redirect(get_option('home'));
      	}
  	}
  	
}
function user_register_email($user_id) {
    $user = new WP_User($user_id);
    $email = $user->user_email;
    $text = get_option('welcome_email_text');
    if(empty($text)) {
        $text = '{%username%}

Welcome to {%sitename%},

Your username is, {%username%} and your password is {%password%},

Regards, {%sitename%}';
    }
    $password = $_SESSION['tmp_pass'];
    unset($_SESSION['tmp_pass']);
    $text = str_replace(array('{%username%}', '{%password%}', '{%sitename%}'), array($user->user_login, $password, get_bloginfo('name') ), $text);
    //$headers = "From: "
    wp_mail( $email, 'Welcome to '.get_bloginfo('name'), $text, $headers);
}
