<?php
 
class Top_Users_Widget extends WP_Widget {
	
	var $prefix;
	var $textdomain;
	
	/**
	 * Set up the widget's unique name, ID, class, description, and other options.
	 * @since 0.7
	 */
	function Top_Users_Widget() {
		$this->prefix = '';
		$this->textdomain = 'top-users-widget';
		
		$this->plugin_file = 'top-users-widget.php';
		$this->settings_url = admin_url( 'widgets.php' );
		$this->donate_url = ''; 
		$this->support_url = ''; 
		
		$widget_ops = array('classname' => 'top-users-widget', 'description' => __('Display top users', $this->textdomain) );
		$this->WP_Widget("{$this->prefix}-top-users-widget", __('Top Users', $this->textdomain), $widget_ops); 
		
	}
	
	/**
	 * Outputs the widget based on the arguments input through the widget controls.
	 */
	function widget($args, $instance) {  
	    global $table_prefix, $wpdb;
		extract( $args );
		
		echo $before_widget;

		/* If there is a title given, add it along with the $before_title and $after_title variables. */
		$title = $instance['title'];
		if ( $title) {
			$title =  apply_filters( 'widget_title',  $title, $instance, $this->id_base );
		}

		//$users = get_users('orderby=post_count');
		$table_name = $table_prefix.'user_points';
		$users = $wpdb->get_results("select u.*, IFNULL(p.points, 0) as u_points from ".$wpdb->users." u left join ".$table_name." p on u.ID=p.user_id order by u_points DESC limit 10");
        
		echo '
		<!--Top Users Widget-->
        ';
        echo $before_title . $title . $after_title;
        
        echo '<ul>';
	
		foreach($users as $user) {
		    //echo '<li class="cat-item cat-item-'.$user->ID.'"><a href="'.get_author_posts_url($user->ID).'" >'.get_avatar($user->ID, 22).get_the_author_meta('display_name', $user->ID).'</a> <span class="user-points">'.$user->u_points.'</span></li>';
		    echo '<li class="cat-item cat-item-'.$user->ID.'"><a href="'.get_bloginfo('home').'/?p='.get_option('viewprofile_page_id').'&profile='.($user->user_login).'" >'.get_user_avatar($user->ID, 22).get_the_author_meta('display_name', $user->ID).'</a> <span class="user-points">'.$user->u_points.'</span></li>';
		}
			
		echo '
		</ul>
        <!--End Top Users Widget-->
        ';
		
	    echo $after_widget;
   }
	
	/**
	 * Updates the widget control options for the particular instance of the widget.
	 */
	function update($new_instance, $old_instance) {                
       return $new_instance;
   }
	
	/**
	 * Displays the widget control options in the Widgets admin screen.
	 */
	function form($instance) {  
		$defaults = array(
			'title' => 'Top Users',
		);
		$instance = wp_parse_args( (array) $instance, $defaults );
   
		?>
		<p>
			<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:', $this->textdomain ); ?></label>
			<input type="text" class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo esc_attr( $instance['title'] ); ?>" />
		</p>
        
       <?php
	}
}
 
add_action('widgets_init', 'register_top_users_widget');

function register_top_users_widget() {
	register_widget('Top_Users_Widget');
}